// JavaScript Document
var cc;
var cs;

var cW;
var cH;

// 初期値
var defNumA = 5;
var defNumD = 3;
var defNumN = 4;

// 設定値
var numA;
var numD;
var numN;
var numL;
var numValueS;

var isPicDraw;
var isShownFormulaS;

// 図の描画カウント 
var digPic;
var digPicMax = 180;
var digPicStep = 10;

var rotatePicID = 0;
var rotatePicDelay = 100;

// 図の描画先
var picView;
var rotateView;
var rotatePicView;

// メニュー幅 
var menuHeight = 290;

// 描画単位
var unitW = 15;
var unitH = 25;

// 描画基準座標 
var padPicX = 20;
var padPicY = 20;

var charAreaX = 40;
var charAreaY = 30;

var stLeft = padPicX + charAreaX;
var stTop = padPicY;

// 記号 
var chrN;
var chrAL;
var chrItemL;
var chrItemR;

// 画面ドラッグ 
var prevX = NaN;
var prevY = NaN;
var dFlag;


function loadContentHandler()
{
	try
	{

		cW = pageWidth - 52;
		cH = pageHeight;

		document.getElementById('configBlock').style.display = 'none';

		var orgBlock = document.getElementById('originalBlock');
		orgBlock.style.position = 'absolute';
		orgBlock.style.left = '0px';
		orgBlock.style.top = '0px';
		orgBlock.style.width = cW + 'px';
		orgBlock.style.height = cH + 'px';
		orgBlock.style.overflowX = 'hidden';
		orgBlock.style.overflowY = 'hidden';

		cc = document.getElementById('contentCanvas');
		cc.width = cW;
		cc.height = cH;

		cc.style.position = 'absolute';
		cc.style.left = '0px';
		cc.style.top = '0px';

		cs = new createjs.Stage(cc);
		createjs.Touch.enable(cs);

		// 図の描画先を作成 
		picView = new createjs.Shape();
		cs.addChild(picView);

		rotateView = new createjs.Container();
		rotatePicView = new createjs.Shape();
		rotateView.addChild(rotatePicView);

		// 変数の初期化 
		chrN = null;
		chrAL = null;
		chrItemR = [];
		chrItemL = [];

		// 初期状態を設定 
		viewSet(true, false);

		// 画面移動関連の設定 
		dFlag = true;
		cs.addEventListener("mousedown", canvasDragStart);

		// 固定パーツのイベントリスナの追加
		document.getElementById('downNumA').addEventListener('click', changeNumHandler);
		document.getElementById('upNumA').addEventListener('click', changeNumHandler);
		document.getElementById('downNumD').addEventListener('click', changeNumHandler);
		document.getElementById('upNumD').addEventListener('click', changeNumHandler);
		document.getElementById('downNumL').addEventListener('click', changeNumHandler);
		document.getElementById('upNumL').addEventListener('click', changeNumHandler);
		document.getElementById('downNumN').addEventListener('click', changeNumHandler);
		document.getElementById('upNumN').addEventListener('click', changeNumHandler);

		document.getElementById("checkB").addEventListener("change", changeCheckHandler);
		document.getElementById("checkS").addEventListener("change", changeCheckHandler);

		document.getElementById('showFormulaS').addEventListener('click', changeViewHandler);
		document.getElementById('resetBtn').addEventListener('click', resetHandler);

		setMenuMode(1, menuHeight);

		checkVersionHandler("1.0.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function changeNumHandler(e) {
	try {
		rotateClear();

		switch (e.currentTarget.id) {
			case 'downNumA':
				numA--;
				if (numA < 1) {
					numA = 1;
				}
				break;
			case 'upNumA':
				numA++;
				if (numA > 99) {
					numA = 99;
				}
				break;
			case 'downNumD':
				numD--;
				if (numD < 1) {
					numD = 1;
				}
				break;
			case 'upNumD':
				numD++;
				if (numD > 99) {
					numD = 99;
				}
				break;
			case 'downNumL':
			case 'downNumN':
				numN--;
				if (numN < 1) {
					numN = 1;
				}
				break;
			case 'upNumL':
			case 'upNumN':
				numN++;
				if (numN > 99) {
					numN = 99;
				}
				break;
		}

		if ($("#checkS").prop("checked")) {
			digPic = digPicMax;
		} else {
			digPic = 0;
		}
		calcAllNumber();
		setFormulaView();
		drawPictureView();

	} catch (e) {
		alert("changeNumHandler:" + e.toString());
	}
}

function changeCheckHandler(e) {
	try {
		rotateClear();

		switch (e.currentTarget.id) {
			case 'checkB':
				isPicDraw = ($(e.currentTarget).prop("checked"));
				digPic = 0;

				$("#checkS").prop("checked", false);
				$("#checkS").prop("disabled", !isPicDraw);

				drawPictureView();
				break;

			case 'checkS':
				if ($(e.currentTarget).prop("checked")) {

					digPic = 0;
					rotatePicView.graphics.clear();
					drawPictureLeft(rotatePicView, chrItemR, stLeft, stTop, unitW, unitH);

					rotateView.x = stLeft + ((numA + numL) * unitW) * 0.5;
					rotateView.y = stTop + (numN * unitH) * 0.5;
					rotateView.regX = rotateView.x;
					rotateView.regY = rotateView.y;

					rotateView.alpha = 0.8;

					cs.addChild(rotateView);
					cs.update();

					rotatePicID = setInterval(rotateIntervalHandler, rotatePicDelay);

				} else {
					digPic = 0;
					drawPictureView();
				}
				break;
		}


	} catch (e) {
		alert("changeCheckHandler:" + e.toString());
	}
}

function changeViewHandler(e) {
	try {
		isShownFormulaS = !isShownFormulaS;
		viewFormulaSSet();

	} catch (e) {
		alert("changeViewHandler:" + e.toString());
	}
}


function rotateIntervalHandler() {
	try {

		// 動作値を加算 
		digPic += digPicStep;

		// 最終値に達している場合は処理を停止する 
		var isStop = (digPic == digPicMax);
		if (!isStop) {
			if (digPicStep > 0) {
				isStop = (digPic > digPicMax);
			} else {
				isStop = (digPic < digPicMax);
			}
		}
		if (isStop) {
			digPic = digPicMax;
			rotateClear();
			drawPictureView();
			return;
		}

		// 回転状態を表示 
		rotateView.rotation = digPic;
		cs.update();

	} catch (e) {
		alert("rotateIntervalHandler:" + e.toString());
	}
}

// 回転状態の初期化 
function rotateClear() {
	try {
		if (rotatePicID != 0) {
			clearInterval(rotatePicID);
		}
		rotateView.rotation = 0;
		rotateView.x = 0;
		rotateView.y = 0;
		rotateView.regX = 0;
		rotateView.regY = 0;

		rotateView.alpha = 1;

		cs.removeChild(rotateView);

	} catch (e) {
		alert("rotateClear:" + e.toString());
	}
}

// 初項と公差と個数から末項の値を取得 
function getCalcValueL(valueA, valueD, valueN) {
	return valueA + valueD * (valueN - 1);
}

// 現在の設定から末項と和を算出
function calcAllNumber() {
	numL = getCalcValueL(numA, numD,numN);
	numValueS = 0.5 * numN * (numA + numL);
}

// 現在の値を数式表示に反映
function setFormulaView() {
	try {
		document.getElementById('aNum').innerHTML = numA.toString();
		document.getElementById('dNum').innerHTML = numD.toString();
		document.getElementById('nNum').innerHTML = numN.toString();
		document.getElementById('lNum').innerHTML = numL.toString();
		document.getElementById('alNumS').innerHTML = (numA + numL).toString();
		document.getElementById('nNumS').innerHTML = numN.toString();
		document.getElementById('valueS').innerHTML = numValueS.toString();
	} catch (e) {
		alert("setFormulaView:" + e.toString());
	}
}

function viewFormulaSSet() {
	try {
		if (isShownFormulaS) {
			document.getElementById('formulaS').style.display = 'block';
			document.getElementById('formulaTblS').style.display = 'inline-block';
		} else {
			document.getElementById('formulaS').style.display = 'none';
			document.getElementById('formulaTblS').style.display = 'none';
		}

	} catch (e) {
		alert("viewFormulaSSet:" + e.toString());
	}
}

// 画面の描画 
function drawPictureView() {
	try {
		var isSizeLine = (digPic == digPicMax);

		var wCharAreaY = charAreaY;
		if (!isSizeLine) {
			wCharAreaY = 0;
		}

		var stRight = stLeft;
		if (digPic != 0) {
			stRight += (numA + numL) * unitW;
		} else {
			stRight += numL * unitW;
		}
		var stBottom = stTop + numN * unitH;

		// 描画先の初期化 
		if (stRight + padPicX > cW) {
			cc.width = stRight + padPicX;
		} else {
			cc.width = cW;
		}
		if (stBottom + wCharAreaY + padPicY > (cH - menuHeight)) {
			cc.height = stBottom + wCharAreaY + padPicY;
		} else {
			cc.height = cH - menuHeight;
		}

		picView.graphics.clear();

		// 画面ドラッグ用の背景を描画 
		if (isPicDraw) {
			picView.graphics.setStrokeStyle(0);
			picView.graphics.beginFill('#FFFFFF');
			picView.graphics.drawRect(stLeft - charAreaX - padPicX, stTop - padPicY, (stRight - stLeft) + padPicX * 2 + charAreaX, (stBottom - stTop) + padPicY * 2 + charAreaY);
			picView.graphics.endFill();
			picView.graphics.endStroke();
		}

		// 寸法線の描画 
		if (isSizeLine) {
			if (!chrN) {
				chrN = createCharText(numN.toString());
			}else{
				chrN.text = numN.toString();
			}
			drawSizeLine(stLeft, stTop, stLeft, stBottom, chrN);

			if (!chrAL) {
				chrAL = createCharText((numA + numL).toString());
			} else {
				chrAL.text = (numA + numL).toString();
			}
			drawSizeLine(stLeft, stBottom, stRight, stBottom, chrAL);
		} else {
			if (chrN) {
				cs.removeChild(chrN);
			}
			if (chrAL) {
				cs.removeChild(chrAL);
			}
		}

		// 右側の描画 
		if (digPic == digPicMax) {
			for (var idxN = 0; idxN < numN; idxN++) {
				var val = getCalcValueL(numA, numD, idxN + 1);
				var w = val * unitW;
				picView.graphics.setStrokeStyle(2);
				picView.graphics.beginStroke('#9A9A9A');
				picView.graphics.drawRect(stRight - w, stBottom - ((idxN + 1) * unitH), w, unitH);
				picView.graphics.endStroke();

				if (!chrItemR[idxN]) {
					chrItemR[idxN] = createCharText(val.toString());
				} else {
					chrItemR[idxN].text = val.toString();
				}
				var rect = chrItemR[idxN].getBounds();
				chrItemR[idxN].x = (w - rect.width) / 2;
				if (chrItemR[idxN].x < 0) {
					chrItemR[idxN].x = 0;
				}
				chrItemR[idxN].x += stRight - w;
				chrItemR[idxN].y = stBottom - ((idxN + 1) * unitH) + ((unitH - rect.height) / 2);
				cs.addChild(chrItemR[idxN]);
			}
		}
		if (chrItemR) {
			var idxS = 0;
			if (digPic == digPicMax) {
				idxS = numN;
			}
			for (var idxN = idxS; idxN < chrItemR.length; idxN++) {
				if (chrItemR[idxN]) {
					if (chrItemR[idxN].parent) {
						chrItemR[idxN].parent.removeChild(chrItemR[idxN]);
					}
				}
			}
		}

		// 左側の描画 
		if (isPicDraw) {
			drawPictureLeft(picView, chrItemL, stLeft, stTop, unitW, unitH);
		} else {
			if (chrItemL) {
				for (var ix = 0; ix < chrItemL.length; ix++) {
					if (chrItemL[ix].parent) {
						chrItemL[ix].parent.removeChild(chrItemL[ix]);
					}
				}
			}
		}

		// 描画内容を反映 
		cs.update();

		// ドラッグされている場合は位置を設定 
		var ccLeft = cc.style.left;
		var ccTop = cc.style.top;
		ccLeft = ccLeft.substring(0, ccLeft.length - 2);
		ccTop = ccTop.substring(0, ccTop.length - 2);

		var limitX = getCanvasDragLimitX();
		var limitY = getCanvasDragLimitY();
		if (ccLeft >= 0) {
			ccLeft = 0;
		} else if (ccLeft <= limitX) {
			ccLeft = limitX;
		}
		if (ccTop >= 0) {
			ccTop = 0;
		} else if (ccTop <= limitY) {
			ccTop = limitY;
		}

		cc.style.left = ccLeft + 'px';
		cc.style.top = ccTop + 'px';

	} catch (e) {
		alert("drawPictureView:" + e.toString());
	}
}

// 画面に表示する文字の作成 
function createCharText(str) {
	try {
		var t = new createjs.Text(str, "20px Times New Roman", "#000000");
		return t;
	} catch (e) {
		alert("createCharText:" + e.toString());
	}
}

// 左側の図形を描画 
function drawPictureLeft(pic, chars, posL, posT, utW, utH) {
	try{
		for (var idxN = 0; idxN < numN; idxN++) {
			var val = getCalcValueL(numA, numD, idxN + 1);
			var w = val * utW;
			pic.graphics.setStrokeStyle(2);
			pic.graphics.beginStroke('#000000');
			pic.graphics.beginFill('#FDE9BC');
			pic.graphics.drawRect(posL, posT + (idxN * utH), w, utH);
			pic.graphics.endFill();
			pic.graphics.endStroke();

			if (!chars[idxN]) {
				chars[idxN] = createCharText(val.toString());
			} else {
				chars[idxN].text = val.toString();
			}
			var rect = chars[idxN].getBounds();
			chars[idxN].x = (w - rect.width) / 2;
			if (chars[idxN].x < 0) {
				chars[idxN].x = 0;
			}
			chars[idxN].x += posL;
			chars[idxN].y = posT + (idxN * utH) + ((utH - rect.height) / 2);
			pic.parent.addChild(chars[idxN]);
		}
		for (var idxN = numN; idxN < chars.length; idxN++) {
			if (chars[idxN]) {
				pic.parent.removeChild(chars[idxN]);
			}
		}
	} catch (e) {
		alert("drawPictureLeft:" + e.toString());
	}
}

// 寸法線の描画 
function drawSizeLine(posSX, posSY, posEX, posEY, txtChar) {
	try{
		var charRect = txtChar.getBounds();
		var charLen = Math.sqrt(Math.pow(charRect.width, 2) + Math.pow(charRect.height, 2));

		var lineR = charLen * 0.475;

		var lineLen = Math.sqrt(Math.pow(posEX - posSX, 2) + Math.pow(posEY - posSY, 2));
		var lineRad = Math.atan2(posEY - posSY, posEX - posSX);

		// 長さが足りる場合のみ線を描画する 
		if (lineLen > lineR * 2.5 + charLen) {
			var lineRPer = lineR / lineLen;
			var charRPer = (charLen * 0.5) / lineLen;

			picView.graphics.setStrokeStyle(1);
			picView.graphics.beginStroke('#9A9A9A');

			var roundCX = ((posEX - posSX) * lineRPer) + posSX;
			var roundCY = ((posEY - posSY) * lineRPer) + posSY;
			var ctrX = lineR * Math.cos(lineRad + Math.PI * 0.75) + roundCX;
			var ctrY = lineR * Math.sin(lineRad + Math.PI * 0.75) + roundCY;
			var wrkX = lineR * Math.cos(lineRad + Math.PI * 0.45) + roundCX;
			var wrkY = lineR * Math.sin(lineRad + Math.PI * 0.45) + roundCY;
			var charX = lineR * Math.cos(lineRad + Math.PI * 0.5) + ((posEX - posSX) * (0.5 - charRPer)) + posSX;
			var charY = lineR * Math.sin(lineRad + Math.PI * 0.5) + ((posEY - posSY) * (0.5 - charRPer)) + posSY;

			picView.graphics.moveTo(posSX, posSY);
			picView.graphics.quadraticCurveTo(ctrX, ctrY, wrkX, wrkY);
			picView.graphics.lineTo(charX, charY);

			charX = lineR * Math.cos(lineRad + Math.PI * 0.5) + ((posSX - posEX) * (0.5 - charRPer)) + posEX;
			charY = lineR * Math.sin(lineRad + Math.PI * 0.5) + ((posSY - posEY) * (0.5 - charRPer)) + posEY;
			roundCX = ((posSX - posEX) * lineRPer) + posEX;
			roundCY = ((posSY - posEY) * lineRPer) + posEY;
			wrkX = lineR * Math.cos(lineRad + Math.PI * 0.55) + roundCX;
			wrkY = lineR * Math.sin(lineRad + Math.PI * 0.55) + roundCY;
			ctrX = lineR * Math.cos(lineRad + Math.PI * 0.25) + roundCX;
			ctrY = lineR * Math.sin(lineRad + Math.PI * 0.25) + roundCY;

			picView.graphics.moveTo(charX, charY);
			picView.graphics.lineTo(wrkX, wrkY);
			picView.graphics.quadraticCurveTo(ctrX, ctrY, posEX, posEY);

			picView.graphics.endStroke();
		}

		// 文字を配置する 
		var charCenterX = lineR * Math.cos(lineRad + Math.PI * 0.5) + (posSX + posEX) * 0.5;
		var charCenterY = lineR * Math.sin(lineRad + Math.PI * 0.5) + (posSY + posEY) * 0.5;
		txtChar.x = charCenterX - (charRect.width * 0.5);
		txtChar.y = charCenterY - (charRect.height * 0.5);
		cs.addChild(txtChar);

	} catch (e) {
		alert("drawSizeLine:" + e.toString());
	}
}

// 画面の設定 
function viewSet(isInitialize, isReset) {
	try {
		rotateClear();

		cc.style.left = '0px';
		cc.style.top = '0px';

		// 設定値を初期化 
		if (isInitialize || isReset) {
			numA = defNumA;
			numD = defNumD;
			numN = defNumN;
			digPic = 0;
			isPicDraw = true;
			isShownFormulaS = false;
		}
		calcAllNumber();

		// 画面表示の設定 
		viewFormulaSSet();
		$("#checkB").prop("checked", isPicDraw);
		$("#checkS").prop("checked", (digPic != 0));
		$("#checkS").prop("disabled", !isPicDraw);

		setFormulaView();
		drawPictureView();

	} catch (e) {
		alert("viewSet:" + e.toString());
	}
}


// +--------------------------+
// | キャンバスのドラッグ     |
// +--------------------------+
function canvasDragStart(e) {
	if (dFlag) {
		prevX = e.stageX;
		prevY = e.stageY;

		if (ictMode) {
			$(window).on("touchend mouseup", dragStop);
		}
		else if (mFlag) {
			document.addEventListener('touchend', dragStop);
		}
		else {
			document.addEventListener('mouseup', dragStop);
		}

		e.currentTarget.addEventListener("pressmove", canvasDragMove);
		e.currentTarget.addEventListener("pressup", canvasDragStop);
	}
}

function canvasDragMove(e) {
	try {
		var p = $("#contentCanvas").position();

		var sX = e.stageX - prevX;
		var sY = e.stageY - prevY;

		var limitX = getCanvasDragLimitX();
		var limitY = getCanvasDragLimitY();

		// Xの差分移動 
		var tmpNewX = p.left + sX;
		if (tmpNewX >= 0) {
			cc.style.left = '0px';
			prevX = e.stageX;
		} else if (tmpNewX <= limitX) {
			cc.style.left = limitX + 'px';
			prevX = e.stageX;
		}
		else {
			cc.style.left = tmpNewX + 'px';
		}

		//Yの差分移動
		var tmpNewY = p.top + sY;
		if (tmpNewY >= 0) {
			cc.style.top = '0px';
			prevY = e.stageY;
		} else if (tmpNewY <= limitY) {
			cc.style.top = limitY + 'px';
			prevY = e.stageY;
		} else {
			cc.style.top = tmpNewY + 'px';
		}

	} catch (e) {
		alert("canvasDragMove:" + e.toString());
	}
}

function getCanvasDragLimitX() {
	if (cc.width > cW) {
		return cW - cc.width;
	}
	return 0;
}

function getCanvasDragLimitY() {
	if (cc.height > (cH - menuHeight)) {
		return (cH - menuHeight) - cc.height;
	}
	return 0;
}

function canvasDragStop(e) {
	try {
		e.currentTarget.removeEventListener("pressmove", canvasDragMove);
		e.currentTarget.removeEventListener("pressup", canvasDragStop);
	} catch (e) {
		alert("canvasDragStop:" + e.toString());
	}
}

function dragStop(e) {
	try {
		if (ictMode) {
			$(window).off("touchend mouseup", dragStop);
		}
		else if (mFlag) {
			document.removeEventListener('touchend', dragStop);
		}
		else {
			document.removeEventListener('mouseup', dragStop);
		}
	} catch (e) {
		alert("dragStop:" + e.toString());
	}
}


function saveContent()
{
	try
	{
		var array = [];
		
		array[0] = numA;
		array[1] = numD;
		array[2] = numN;
		array[3] = isPicDraw;
		array[4] = (digPic != 0);
		array[5] = isShownFormulaS;

		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

function loadContent(array)
{
	try
	{
		numA = array[0];
		numD = array[1];
		numN = array[2];
		isPicDraw = array[3];
		var isDigPic = array[4];
		isShownFormulaS = array[5];

		digPic = (isDigPic) ? digPicMax : 0;

		viewSet(false, false);
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}

function resetHandler(e) {
	try
	{
		viewSet(false, true);
	}
	catch(e)
	{
		alert('resetHandler:' + e.toString());
	}
}