// JavaScript Document
/*使用するイベントハンドラではthisがイベント登録対象になるのでAnimeBalloonであるthisを変数で格納*/
var animeTimer;
var animeBalloon;

AnimeBalloon = function(min, max, def, w, h, f, s, change, capture, remove, lMin, lMax)
{
	try
	{
		animeBalloon = this;
		
		this.min;
		this.max;
		
		this.def;
		this.prev;
		
		this.radFlag;
		this.span;
		
		this.speedArray = [0.2, 0.5, 1, 2, 5];
		this.speedIndex = 2;
		
		this.targetID = "";
		
		this.ss = new createjs.Stage(document.getElementById("balloonCanvas"));
		
		this.scW  = w;
		this.scH = h;
		
		document.getElementById("balloonCanvas").width = w;
		document.getElementById("balloonCanvas").height = h;
		
		//変更時に呼び出す関数
		this.changeFnc = change;
		
		//キャプチャ時に呼び出す関数
		this.captureFnc = capture;
		
		//キャプチャ削除時に呼び出す関数
		this.removeFnc = remove;
		
		this.limitMin;
		this.limitMax;
		
		if(lMin != null)
		{
			this.limitMin = lMin;
		}
		
		if(lMax != null)
		{
			this.limitMax = lMax;
		}
		
		this.pointSpan;
		
		this.marginTB = 5;
		this.marginLR = 5;
		
		this.loopMode = 0;
		this.loopFlag = true;
		
		this.sLine = new createjs.Shape();
		this.ss.addChild(this.sLine);
		
		this.sPoint = new createjs.Shape();
		this.sPoint.graphics.setStrokeStyle(0);
		this.sPoint.graphics.beginStroke("#000000");
		this.sPoint.graphics.beginFill("#000000");
		this.sPoint.graphics.drawCircle(0, 0, 5);
		this.sPoint.graphics.endFill();
		this.sPoint.graphics.endStroke();
		this.ss.addChild(this.sPoint);
		
		/*値を設定*/
		setSliderData(min, max, def, def, f, s);
		
		initAnimeBalloon();
	}
	catch(e)
	{
		alert("AnimeBalloon setAnimeBalloon:" + e.toString());
	}
};

function initAnimeBalloon()
{
	try
	{
		//最小・最大変更
		document.getElementById("slMin").addEventListener("click", changeLimitHandler);
		document.getElementById("srMin").addEventListener("click", changeLimitHandler);
		
		document.getElementById("slMax").addEventListener("click", changeLimitHandler);
		document.getElementById("srMax").addEventListener("click", changeLimitHandler);
		
		//再生
		document.getElementById("playBtn").addEventListener("click", playAnimationHandler);
		
		//ループ
		document.getElementById("loopBtn").addEventListener("click", changeLoopHandler);
		
		//速度
		document.getElementById("speedConfig").addEventListener("click", changeSpeedHandler);
		
		//削除
		document.getElementById("captureBtn").addEventListener("click", captureDataHandler);
		
		//削除
		document.getElementById("removeBtn").addEventListener("click", removeCaptureHandler);
		
	}
	catch(e)
	{
		alert("initAnimeBalloon:" + e.toString());
	}
}

function setSliderData(min, max, def, prev, f, s)
{
	try
	{
		animeBalloon.min = min;
		animeBalloon.max = max;
		animeBalloon.def = def;
		animeBalloon.prev = prev;
		
		animeBalloon.radFlag = f;
		animeBalloon.span = s;
		
		//角度の設定の場合
		if(f)
		{
			setRadiusNumber(document.getElementById("tMin"), min);
			setRadiusNumber(document.getElementById("tMax"), max);
		}
		else
		{
			document.getElementById("tMin").innerHTML = min;
			document.getElementById("tMax").innerHTML = max;
			
			$("#tMin").css("margin", "0px 10px");
			$("#tMax").css("margin", "0px 10px");
		}
		
		animeBalloon.changeSliderLine();
		animeBalloon.changeSliderPoint();
	}
	catch(e)
	{
		alert("setSliderData:" + e.toString());
	}
}

function changeLimitHandler(e)
{
	try
	{

		if(animeFlag == false)
		{
			var f = false;
			
			if(animeBalloon.radFlag)
			{
				var step = [];
				for(var i=0; i<=360; i+=15)
				{
					step.push(i);
				}
				
				var minIndex = step.indexOf(animeBalloon.min);
				var maxIndex = step.indexOf(animeBalloon.max)
				
				//最小値の変更
				if(e.target.id.indexOf("Min") != -1)
				{
					if(e.target.id == "slMin" && minIndex > 0)
					{
						animeBalloon.min = step[minIndex-1];
						f = true;
					}
					else if(e.target.id == "srMin" && minIndex+1 < maxIndex)
					{
						animeBalloon.min = step[minIndex+1];
						f = true;
					}
					
					if(f)
					{
						setRadiusNumber(document.getElementById("tMin"), animeBalloon.min);
					}
				}
				//最大値の変更
				else
				{
					if(e.target.id == "srMax" && maxIndex < step.length-1)
					{
						animeBalloon.max = step[maxIndex+1];
						f = true;
					}
					else if(e.target.id == "slMax" && maxIndex-1 > minIndex)
					{
						animeBalloon.max = step[maxIndex-1];
						f = true;
					}
					
					if(f)
					{
						setRadiusNumber(document.getElementById("tMax"), animeBalloon.max);
					}
				}
			}
			else
			{
				//最小値の変更
				if(e.target.id.indexOf("Min") != -1)
				{
					if(e.target.id == "slMin")
					{
						var m0 = animeBalloon.min - animeBalloon.span;

						m0 = Math.round(m0 * 10000)/10000;
						
						if(animeBalloon.limitMin != null && m0 <= animeBalloon.limitMin)
						{
							m0 = animeBalloon.limitMin;
						}
						
						//浮動小数点対策
						animeBalloon.min = m0;

						f = true;
					}
					else if(e.target.id == "srMin" && animeBalloon.min+animeBalloon.span < animeBalloon.max)
					{
						var m1 = animeBalloon.min + animeBalloon.span;

						m1 = Math.round(m1 * 10000)/10000;

						//浮動小数点対策
						animeBalloon.min = m1;

						f = true;
					}

					if(f)
					{
						document.getElementById("tMin").innerHTML = animeBalloon.min;
					}
				}
				//最大値の変更
				else
				{
					if(e.target.id == "srMax")
					{
						var m2 = animeBalloon.max + animeBalloon.span;

						m2 = Math.round(m2 * 10000)/10000;
						
						if(animeBalloon.limitMax != null && m2 >= animeBalloon.limitMax)
						{
							m2 = animeBalloon.limitMax;
						}

						//浮動小数点対策
						animeBalloon.max = m2;

						f = true;
					}
					else if(e.target.id == "slMax" && animeBalloon.max-animeBalloon.span > animeBalloon.min)
					{
						var m3 = animeBalloon.max - animeBalloon.span;

						m3 = Math.round(m3 * 10000)/10000;

						//浮動小数点対策
						animeBalloon.max = m3;

						f = true;
					}

					if(f)
					{
						document.getElementById("tMax").innerHTML = animeBalloon.max;
					}
				}
			}
			
			if(f)
			{
				var f1 = false;
				
				//コントロールの位置が変わる場合
				if(animeBalloon.prev < animeBalloon.min)
				{
					animeBalloon.prev = animeBalloon.min;
					f1 = true;
				}
				else if(animeBalloon.prev > animeBalloon.max)
				{
					animeBalloon.prev = animeBalloon.max;
					f1 = true;
				}

				if(f1)
				{
					animeBalloon.changeFnc();
				}

				//スライダの状態を変更
				animeBalloon.changeSliderLine();
				animeBalloon.changeSliderPoint();
			}
		}
	}
	catch(e)
	{
		alert("AnimeBalloon changeLimitHandler:" + e.toString());
	}
}


function setRadiusNumber(elm, num)
{
	try
	{
		
		var str;
		
		//弧度法の場合
		if(document.getElementById("methodText").innerHTML == "弧度法")
		{
			str = getRadiusHtml(num, true);
		}
		else
		{
			str = getRadiusHtml(num, false);
		}
		
		//content.jsに記述したchangeMathJaxで対象の表記を変更
		$("#"+elm.id).html(str);
	}
	catch(e)
	{
		alert("setRadiusNumber:" + e.toString());
	}
}

AnimeBalloon.prototype.changeAnimeRadiusDisplay = function()
{
	try
	{
		var strMin;
		var strMax;
		
		//弧度法の場合
		if(document.getElementById("methodText").innerHTML == "弧度法")
		{
			strMin = getRadiusTex(this.min, true);
			strMax = getRadiusTex(this.max, true);
		}
		else
		{
			strMin = getRadiusTex(this.min, false);
			strMax = getRadiusTex(this.max, false);
		}
		
		strMin = "\\small{"+strMin+"}";
		strMax = "\\small{"+strMax+"}";
		
		//content.jsに記述したchangeMathJaxで対象の表記を変更
		changeMathJax("tMin", strMin, false);
		changeMathJax("tMax", strMax, false);
	}
	catch(e)
	{
		alert("changeAnimeRadiusDisplay:" + e.toString());
	}
}

AnimeBalloon.prototype.changeSliderLine = function()
{
	try
	{
		this.sLine.graphics.clear();
		
		this.sLine.graphics.setStrokeStyle(2);
		this.sLine.graphics.beginStroke("#000000");
		this.sLine.graphics.moveTo(this.marginLR, this.scH/2);
		
		this.sLine.graphics.lineTo(this.scW-this.marginLR, this.scH/2);
		
		var i;
		
		if(animeBalloon.radFlag)
		{
			var step = [];
			for(var i=0; i<=360; i+=15)
			{
				step.push(i);
			}
				
			i = step.indexOf(this.min);
			j = step.indexOf(this.max);
			
			var minRad = step[i];
			var maxRad = step[j];
			
			var radSpan = maxRad-minRad;
			var leng = this.scW - this.marginLR * 2;
			
			//末尾の縦線
			this.sLine.graphics.moveTo(this.scW-this.marginLR, animeBalloon.scH/2-animeBalloon.marginTB*2);
			this.sLine.graphics.lineTo(this.scW-this.marginLR, animeBalloon.scH/2+animeBalloon.marginTB*2);
			
			var f = true;
			
			for(i; i<j; i++)
			{
				var rX = leng * (step[i]-minRad)/radSpan;
				
				if(f || step[i] == 180)
				{
					this.sLine.graphics.moveTo(animeBalloon.marginLR+rX, animeBalloon.scH/2-animeBalloon.marginTB*2);
					this.sLine.graphics.lineTo(animeBalloon.marginLR+rX, animeBalloon.scH/2+animeBalloon.marginTB*2);
					
					f = false;
				}
				else
				{
					this.sLine.graphics.moveTo(animeBalloon.marginLR+rX, animeBalloon.scH/2-animeBalloon.marginTB);
					this.sLine.graphics.lineTo(animeBalloon.marginLR+rX, animeBalloon.scH/2+animeBalloon.marginTB);
				}
			}
		}
		else
		{
			//角度の設定でも動作するように整数値のカウントで処理するように設定
			var cnt = Math.round((animeBalloon.max - animeBalloon.min)/animeBalloon.span);
			animeBalloon.pointSpan = (animeBalloon.scW-animeBalloon.marginLR*2)/cnt;

			for(i=0; i<=cnt; i++)
			{
				//最小・最大・0の場合
				if(i==0 || i==cnt || Math.round(-animeBalloon.min/animeBalloon.span) == i)
				{
					animeBalloon.sLine.graphics.moveTo(animeBalloon.marginLR+i * animeBalloon.pointSpan, animeBalloon.scH/2-animeBalloon.marginTB*2);
					animeBalloon.sLine.graphics.lineTo(animeBalloon.marginLR+i * animeBalloon.pointSpan, animeBalloon.scH/2+animeBalloon.marginTB*2);
				}
				else
				{
					animeBalloon.sLine.graphics.moveTo(animeBalloon.marginLR+i * animeBalloon.pointSpan, animeBalloon.scH/2-animeBalloon.marginTB);
					animeBalloon.sLine.graphics.lineTo(animeBalloon.marginLR+i * animeBalloon.pointSpan, animeBalloon.scH/2+animeBalloon.marginTB);
				}
			}

			animeBalloon.sLine.graphics.endStroke();
		}
		
		animeBalloon.ss.update();
	}
	catch(e)
	{
		alert("AnimeBalloon changeSliderLine:" + e.toString());
	}
};


AnimeBalloon.prototype.changeSliderControl = function()
{
	try
	{
		//バルーンでのアニメーション制御では使用しない（スライダーでは矢印で移動）
		return;
	}
	catch(e)
	{
		alert("AnimeBalloon changeSliderControl:" + e.toString());
	}
};


AnimeBalloon.prototype.changeSliderPoint = function()
{
	try
	{
		animeBalloon.sPoint.y =animeBalloon.scH/2;
		
		if(animeBalloon.radFlag)
		{
			var step = [];
			for(var i=0; i<=360; i+=15)
			{
				step.push(i);
			}
				
			var leng = this.scW - this.marginLR * 2;
			
			animeBalloon.sPoint.x = animeBalloon.marginLR+ leng * (this.prev-this.min)/(this.max-this.min);
		}
		else
		{
			animeBalloon.sPoint.x = animeBalloon.marginLR + Math.round((animeBalloon.prev - animeBalloon.min)/animeBalloon.span) * animeBalloon.pointSpan;
		}
		
		animeBalloon.ss.update();
	}
	catch(e)
	{
		alert("AnimeBalloon changeSliderPoint:" + e.toString());
	}
};

AnimeBalloon.prototype.openAnimeBalloon = function(id)
{
	try
	{
		if(this.targetID != id)
		{
			this.targetID = id;
			
			var eX = $("#"+id).position().left;
			var pX = $("#"+id).parent().position().left;
			
			var eW = $("#"+id).outerWidth();
			
			$("#animeBalloon").css("margin-left", "28px");
			
			$("#animeTriangle").css("margin-left", eX+pX+eW/2+7-28);
			
			document.getElementById("animeBalloon").style.display = "inline-block";
			
		}
		else
		{
			animeBalloon.closeAnimeBalloon();
		}
	}
	catch(e)
	{
		alert("openAnimeBalloon:" + e.toString());
	}
}

AnimeBalloon.prototype.closeAnimeBalloon = function()
{
	try
	{
		this.targetID = "";
			
		document.getElementById("animeBalloon").style.display = "none";
	}
	catch(e)
	{
		alert("closeAnimeBalloon:" + e.toString());
	}
}

function playAnimationHandler(e)
{
	try
	{
		if(animeFlag == false)
		{
			document.getElementById("playBtn").src = "./img/stopIcon.png";

			startAnimation();
		}
		else
		{
			clearTimeout(animeTimer);
			document.getElementById("playBtn").src = "./img/playIcon.png";
		}

		animeFlag = !animeFlag;
	}
	catch(e)
	{
		alert("AnimeBalloon playAnimationHandler:" + e.toString());
	}
}


function startAnimation()
{
	try
	{
		//　1/5秒ごとに表示変更
		var sec = 500 / animeBalloon.speedArray[animeBalloon.speedIndex];
		
		if(animeBalloon.radFlag == false && animeBalloon.loopMode == 2)
		{
			if(animeBalloon.prev >= animeBalloon.max)
			{
				animeBalloon.prev = animeBalloon.min - animeBalloon.span;
			}
		}
		
		animeTimer = setTimeout(stopAnimation, sec);
	}
	catch(e)
	{
		alert("startAnimation:" + e.toString());
	}
}

function stopAnimation()
{
	try
	{
		clearTimeout(animeTimer);
		
		//スライド全体でのデフォルト(1x)でのミリ秒数
		var d = 10000;
		var s = 500 / animeBalloon.speedArray[animeBalloon.speedIndex];
		
		
		//角度変更の場合
		if(animeBalloon.radFlag)
		{
			var step = [];
			for(var i=0; i<=360; i+=15)
			{
				step.push(i);
			}
			
			var pIndex = step.indexOf(animeBalloon.prev);
			
			if(animeBalloon.loopFlag)
			{
				animeBalloon.prev = step[pIndex+1];
			}
			else
			{
				animeBalloon.prev = step[pIndex-1];
			}
		}
		else
		{
			if(animeBalloon.loopFlag)
			{
				animeBalloon.prev += animeBalloon.span;
			}
			else
			{
				animeBalloon.prev -= animeBalloon.span;
			}
			
			//浮動小数点対策
			animeBalloon.prev = Math.round(animeBalloon.prev * 10000)/10000;
		}
		
		if(animeBalloon.prev < animeBalloon.min)
		{
			animeBalloon.prev = animeBalloon.min;
		}
		else if(animeBalloon.prev > animeBalloon.max)
		{
			animeBalloon.prev = animeBalloon.max;
		}
		
		animeBalloon.changeSliderPoint();
		
		animeBalloon.changeFnc();
		
		animeBalloon.ss.update();
		
		//繰り返し
		if(animeBalloon.loopMode == 0)
		{
			//順行
			if(animeBalloon.loopFlag == true)
			{
				if(animeBalloon.prev >= animeBalloon.max)
				{
					animeBalloon.loopFlag = false;
				}
			}
			//逆行
			else
			{
				if(animeBalloon.prev <= animeBalloon.min)
				{
					animeBalloon.loopFlag = true;
				}
			}
			
			startAnimation();
		}
		else if(animeBalloon.loopMode == 1)
		{
			if(animeBalloon.prev >= animeBalloon.max)
			{
				animeBalloon.prev = animeBalloon.min - animeBalloon.span;
			}
			
			startAnimation();
		}
		else
		{
			if(animeBalloon.prev < animeBalloon.max)
			{
				startAnimation();
			}
			else
			{
				//アニメーション終了
				document.getElementById("playBtn").src = "./img/playIcon.png";
				animeFlag = false;
			}
		}
	}
	catch(e)
	{
		alert("AnimeBalloon stopAnimation:" + e.toString());
	}
}

function changeLoopHandler(e)
{
	try
	{
		switch(animeBalloon.loopMode)
		{
			case 0:
				animeBalloon.loopMode = 1;
				animeBalloon.loopFlag = true;
				document.getElementById("loopBtn").src = "./img/autoIcon.png";
				break;

			case 1:
				animeBalloon.loopMode = 2;
				document.getElementById("loopBtn").src = "./img/normalIcon.png";
				break;

			case 2:
				animeBalloon.loopMode = 0;
				animeBalloon.loopFlag = false;
				document.getElementById("loopBtn").src = "./img/loopIcon.png";
				break;
		}
	}
	catch(e)
	{
		alert("AnimeBalloon changeLoopHandler:" + e.toString());
	}
}

function changeSpeedHandler(e)
{
	try
	{
		if(animeBalloon.speedIndex+1 < animeBalloon.speedArray.length)
		{
			animeBalloon.speedIndex+=1;
		}
		else
		{
			animeBalloon.speedIndex = 0;
		}
		
		document.getElementById("speedConfig").src = "./img/s"+animeBalloon.speedArray[animeBalloon.speedIndex]+".png";
	}
	catch(e)
	{
		alert("changeSpeedHandler:" + e.toString());
	}
}

function captureDataHandler(e)
{
	try
	{
		animeBalloon.captureFnc();
	}
	catch(e)
	{
		alert(e.toString());
	}
}

function removeCaptureHandler(e)
{
	try
	{
		animeBalloon.removeFnc();
	}
	catch(e)
	{
		alert(e.toString());
	}
}


