// JavaScript Document
function changeArrowShape(s, x0, y0, x1, y1, c, f)
{
	try
	{
		/*
		s：矢印を描画するShape
		x0：始点のx座標
		y0：始点のy座標
		x1：終点のx座標
		y1：終点のy座標
		c：色
		f：矢印の設定　true：通常 false：文字の上の矢印
		*/
		s.graphics.clear();
		
		var leng = Math.sqrt((x0-x1)*(x0-x1)+(y0-y1)*(y0-y1));
		var rad = Math.atan2(y1-y0, x1-x0);
		
		
		
		var rad3 = Math.atan2(y0-y1, x0-x1);
		var x3_0, y3_0;
		var x3_1, y3_1;
		
		var ar = 20;
		
		if(f == false)
		{
			s.graphics.setStrokeStyle(1);
			leng -= 3;
			
			x3_0 = x1 + 5 * Math.cos(rad3+ar*Math.PI/180);
			y3_0 = y1 + 5 * Math.sin(rad3+ar*Math.PI/180);
			
			x3_1 = x1 + 5 * Math.cos(rad3-ar*Math.PI/180);
			y3_1 = y1 + 5 * Math.sin(rad3-ar*Math.PI/180);
		}
		else
		{
			if(f == true)
			{
				s.graphics.setStrokeStyle(2, 1);
			}
			else
			{
				s.graphics.setStrokeStyle(f, 1);
			}
			
			leng -= 6;
			
			x3_0 = x1 + 9 * Math.cos(rad3+ar*Math.PI/180);
			y3_0 = y1 + 9 * Math.sin(rad3+ar*Math.PI/180);
			
			x3_1 = x1 + 9 * Math.cos(rad3-ar*Math.PI/180);
			y3_1 = y1 + 9 * Math.sin(rad3-ar*Math.PI/180);
		}
		
		var x2 = x0 + leng * Math.cos(rad);
		var y2 = y0 + leng * Math.sin(rad);
		
		s.graphics.beginStroke(c);
		
		//線部分
		s.graphics.moveTo(x0, y0);
		s.graphics.lineTo(x2, y2);
		s.graphics.endStroke();
		
		//矢印部分
		if(f == true || f == false)
		{
			s.graphics.setStrokeStyle(0);
		}
		else
		{
			s.graphics.setStrokeStyle(f);
		}
		
		s.graphics.beginStroke(c);
		s.graphics.beginFill(c);
		s.graphics.moveTo(x2, y2);
		s.graphics.lineTo(x3_0, y3_0);
		s.graphics.lineTo(x1, y1);
		s.graphics.lineTo(x3_1, y3_1);
		s.graphics.lineTo(x2, y2);
		s.graphics.endFill();
		
		s.graphics.endStroke();
		
	}
	catch(e)
	{
		alert("changeArrowShape:" + e.toString());
	}
}