// JavaScript Document
function sqrtSimplify(n)
{
	try
	{
		//素因数分解
		var d = primeFactorization(n);
		var j = d.length;
		
		var result = [1, 1];

		for(var i=0; i<j; i++)
		{
			if(d[i].r == 1)
			{
				result[1] = result[1] * d[i].num;
			}
			else if(d[i].r%2 == 0)
			{
				result[0] = result[0] * Math.pow(d[i].num, parseInt(d[i].r/2));
			}
			else
			{
				if(d[i].r > 1)
				{
					result[0] = result[0] * Math.pow(d[i].num, parseInt(d[i].r/2));
				}
				
				result[1] = result[1] * d[i].num;
			}
		}

		return result;
	}
	catch(e)
	{
		alert("getSqrtSimplify:" + e.toString());
	}
}

function primeFactorization(n) 
{
	try
	{
		// 平方根を保存
		var s = Math.floor(Math.sqrt(n));

		var r = 0;

		var result = Array();

		// 2から平方根までの素因数を求める
		for (var i = 2;i <= s;i++) {

			if ((n % i) == 0) {

				r = 0; // 指数カウンタクリア

				do {

					r++; // 指数カウンタプラス

					n = n / i;

				} while ((n % i) == 0);

				// 素因数iを指数とともに保存
				result.push({num:i, r:r});

			}

		}

		// 残った素数を追加
		if (n > s) {
			result.push({num:n, r:1});
		}

		return result;
	}
	catch(e)
	{
		alert("primeFactorization:" + e.toString());
	}
}